/* Fitxer: Array2.java
   Descripci: Exemple de gesti de taules multidimensionals via reflexi
   Autor: Glen McCluskey - Article "Using Java Reflection"
          Documentaci de Java referent a "Reflection"
*/
import java.lang.reflect.*;
        
public class Array2 
{
   public static void main(String args[])
   {
      int dims[] = new int[]{5, 10, 15};
      Object arr = Array.newInstance(Integer.TYPE, dims);
      // arr s una taula d'Integer de 3 dimensions: 5, 10, 15
      // Per donar visibilitat:
      // arr s una referncia a una taula de 5 celles
      // on cada cella s una referncia a una taula de 10 celles
      // cadascuna de les quals, s una referncia a una taula de 15 celles
      Object arrobj = Array.get(arr, 3);
      // arrobj apunta a la taula de 10 celles que era apuntada per arr[3]
      Class cls = arrobj.getClass().getComponentType();
      System.out.println(cls);
      // Aquest missatge ens ha de retornar que es tracta d'una taula.
      // Utilitzar la nomenclatura class [I
      // Tot i que s una taula de 2 dimensions, no ens ho informa
      arrobj = Array.get(arrobj, 7);
      // arrobj apunta a la taula de 15 celles que era apuntada per arr[3][7]
      Array.setInt(arrobj, 12, 37);
      // Hem ubicat l'Integer 37 a la posici 12 de la taula apuntada per arr[3][7],
      // s a dir, hem ubicat l'Integer 37 a la posici arr[3][7][12]
      int arrcast[][][] = (int[][][])arr;
      // Hem creat una referncia "arrcast" a una taula tridimensional i li hem assignat
      // la taula tridimensional apuntada per "arr"
      System.out.println(arrcast[3][7][12]);
      // Accedim a la posici de la taula "arr" on havem intentat ubicar l'Integer 37
      // utilitzant la referncia "arrcast" que ens permet utilitzar els claudtors per
      // accedir a qualsevol posici, fet que no podem utilitzar amb la referncia "arr"
      // donat que no est definida com a taula. Hagussim, per, pogut fer cast:
      System.out.println(((int[][][])arr)[3][7][12]);
   }
}
