/* Fitxer: Method1.java
   Descripci: Facilita informaci detallada per tots els mtodes no constructors d'una classe
               (parmetres, excepcions que llancen i valor de retorn)
   Autor: Glen McCluskey - Article "Using Java Reflection"
          Documentaci de Java referent a "Reflection"
*/
import java.lang.reflect.*;

public class Method1
{  
   private int f1(Object p, int x) throws NullPointerException
   {
      if (p == null)
         throw new NullPointerException();
      return x;
   }

   public static void main(String args[])
   {
      try 
      {
         Class cls = Class.forName("Method1");
         Method methlist[] = cls.getDeclaredMethods();
         for (int i = 0; i < methlist.length; i++)
         {
            Method m = methlist[i];
            System.out.println("name = " + m.getName());
            System.out.println("decl class = " + m.getDeclaringClass());
            Class pvec[] = m.getParameterTypes();
            for (int j = 0; j < pvec.length; j++)
               System.out.println(" param #" + j + " " + pvec[j]);
            Class evec[] = m.getExceptionTypes();
            for (int j = 0; j < evec.length; j++)
               System.out.println("exc #" + j + " " + evec[j]);
            System.out.println("return type = " + m.getReturnType());
            System.out.println("-----");
         }
      }
      catch (Throwable e) 
      {
         System.err.println(e);
      }
   }
}
