/* Fitxer: ProvaComparator.java
   Descripci: Definici d'una classe que implementa la interfcie Comparator
               per establir ordre entre objectes de classes tant dispars com:
               Persona, Date, Double i Short.
   Autor: Isidre Guix
*/

import java.util.*;

public class ProvaComparator
{
   public static void main (String args[])
   {
      Object t[] = new Object[6];
      t[0] = new Alumne("99999999","Anna",20);
      t[1] = new Date();
      t[2] = new Alumne("22222222","Maria",40,'s');
      t[3] = new Short((short)22);
      t[4] = new Double(33.33);
      t[5] = new Date(109,0,1);
      System.out.println("Contingut inicial de la taula:");
      for (int i=0; i<t.length; i++) System.out.println("   "+t[i].getClass().getName()+" - "+t[i]);
      Arrays.sort(t,new xComparator());
      System.out.println("Contingut de la taula desprs d'haver estat ordenada:");
      for (int i=0; i<t.length; i++) System.out.println("   "+t[i].getClass().getName()+" - "+t[i]);
   }
}

/* La segent classe defineix l'ordre entre objectes de les classes Persona, Date, Double i Short
   de manera que: Date < Double < Persona < Short
   Entre objectes de la mateixa classe, l'ordre el defineix l'ordre natural definit per la
   implementaci del mtode compareTo() de la interfcie Comparable
*/
class xComparator implements Comparator <Object>
{
   public int compare (Object o1, Object o2)
   {
      if (o1 instanceof Date)
         if (o2 instanceof Date) return ((Date)o1).compareTo((Date)o2);
         else return -1;
      else if (o1 instanceof Double)
         if (o2 instanceof Date) return 1;
         else if (o2 instanceof Double) return ((Double)o1).compareTo((Double)o2);
              else return -1;
      else if (o1 instanceof Persona)
         if (o2 instanceof Date || o2 instanceof Double) return 1;
         else if (o2 instanceof Persona) return ((Persona)o1).compareTo((Persona)o2);
              else return -1;
      else if (o1 instanceof Short)
         if (o2 instanceof Short) return ((Short)o1).compareTo((Short)o2);
         else return 1;
      else throw new ClassCastException();
   }
}