/* Fitxer: VectorValorsNumerics.java
   Descripci: Exemple d'utilitzaci de la classe Vector
   Autor: Isidre Guix
*/

import java.util.Vector;

class VectorValorsNumerics extends Vector<Number>
{
   public VectorValorsNumerics(int capacitatInicial, int increment)
   {
      super(capacitatInicial, increment);
   }
   
   public double mitja ()
   {
      double suma=0;
      int valorsNoNuls=0;
      for (int i=0; i<size(); i++) 
      {
         suma = suma + get(i).doubleValue();
         valorsNoNuls++;
      }
      if (valorsNoNuls==0) return 0;
      else return suma / valorsNoNuls;
   }

   public boolean mateixaMitja (VectorValorsNumerics obj)
   {
      return mitja() == obj.mitja();
   }
   
   public boolean mateixNombreElements (VectorValorsNumerics obj)
   {
      return size() == obj.size();
   }

   public boolean mateixaCapacitat (VectorValorsNumerics obj)
   {
      return capacity() == obj.capacity();
   }

   public String toString()
   {
      String s="{";
      for (int i=0; i<size(); i++)
         if (s.equals("{")) s = s + get(i);
         else s = s + ", " + get(i);
      s = s + "}";
      return s;
   }

   public static void main (String args[])
   {
      Integer ti[]={1,2,3,4,5};
      Double td[]={1.1,2.2,3.3,4.4,5.5,6.6,7.7,8.8,9.9,10.10};
      VectorValorsNumerics vvn1 = new VectorValorsNumerics (5,2);
      VectorValorsNumerics vvn2 = new VectorValorsNumerics (5,3);
      int i;
      
      for (i=0; i<ti.length && i<td.length; i++)
      {  vvn1.add(ti[i]); vvn1.add(td[i]); vvn2.add(ti[i]); vvn2.add(td[i]);}
      for (; i<ti.length; i++)
      {  vvn1.add(ti[i]); vvn2.add(ti[i]);}
      for (; i<td.length; i++)
      {  vvn1.add(td[i]); vvn2.add(td[i]);}
 
      System.out.println("vvn1: "+vvn1);
      System.out.println("   Mitja       : "+vvn1.mitja());
      System.out.println("   Nre.Elements: "+vvn1.size());
      System.out.println("   Capacitat...: "+vvn1.capacity());
      System.out.println("vvn2: "+vvn2);
      System.out.println("   Mitja       : "+vvn2.mitja());
      System.out.println("   Nre.Elements: "+vvn2.size());
      System.out.println("   Capacitat...: "+vvn2.capacity());
      System.out.println("vvn1 i vvn2 tenen la mateixa mitja? " + vvn1.mateixaMitja(vvn2));
      System.out.println("vvn1 i vvn2 tenen el mateix nombre d'elements? " + vvn1.mateixNombreElements(vvn2));
      System.out.println("vvn1 i vvn2 tenen la mateixa capacitat? " + vvn1.mateixaCapacitat(vvn2));
   }
}